//Tail.cs
datablock AudioProfile(TailShot1Sound)
{
   filename    = "./tailwhip.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(TailDrawSound)
{
   filename    = "./TailDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(TailHitSound)
{
   filename    = "./TailHit.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(TailExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.7 0.7 0.9 0.9";
   colors[1]     = "0.9 0.9 0.9 0.0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(TailExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TailExplosionParticle";

   uiName = "Tail Hit";
};

datablock ExplosionData(TailExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = TailHitSound;

   particleEmitter = TailExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("Tail",   '<bitmap:add-ons/Weapon_AlienTail/CI_Tail> %1',    '%2 <bitmap:add-ons/Weapon_AlienTail/CI_Tail> %1',0.75,1);
datablock ProjectileData(TailProjectile)
{
   directDamage        = 90;
   directDamageType  = $DamageType::Tail;
   radiusDamageType  = $DamageType::Tail;
   explosion           = TailExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 1;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Tail Slice";
};


//////////
// item //
//////////
datablock ItemData(TailItem)
{
    category = "Weapon";  // Mission editor category
    className = "Weapon"; // For inventory system

     // Basic Item Properties
    shapeFile = "./empty.dts";
    mass = 1;
    density = 0.2;
    elasticity = 0.2;
    friction = 0.6;
    emap = true;

    //gui stuff
    uiName = "Tail";
    iconName = "./icon_Tail";
    doColorShift = true;
    colorShiftColor = "0.471 0.471 0.471 1.000";

     // Dynamic properties defined by the scripts
    image = TailImage;
    canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(TailImage)
{
   // Basic Item properties
   shapeFile = "./empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";

   className = "TF2MeleeWeaponImage";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = TailItem;
   ammo = " ";
   projectile = TailProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Raycast Stuff, pay attention, this stuff's on the test.
   raycastWeaponRange = 3;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastExplosionProjectile = TailProjectile;
   raycastExplosionBrickSound = TailHitSound;
   raycastExplosionPlayerSound = PlayerHitSound;
   raycastDirectDamage = 90;
   raycastDirectDamageType = $DamageType::Tail;
   raycastCritDirectDamageType = $DamageType::Tail;

   // Initial start up state
    stateName[0]                     	= "Activate";
    stateTimeoutValue[0]             	= 0.1;
    stateTransitionOnTimeout[0]      	= "Ready";
    stateSound[0]                    	= TailDrawSound;

    stateName[1]                     	= "Ready";
    stateTransitionOnTriggerDown[1]  	= "PreFire";
    stateAllowImageChange[1]         	= true;

    stateName[2]            		= "PreFire";
    stateScript[2]                  	= "onPreFire";
    stateAllowImageChange[2]        	= false;
    stateSound[2]                    	= TailShot1Sound;
    stateTimeoutValue[2]            	= 0.1;
    stateTransitionOnTimeout[2]     	= "Fire";

    stateName[3]                    	= "Fire";
    stateTransitionOnTimeout[3]     	= "StopFire";
    stateTimeoutValue[3]            	= 0.6;
    stateFire[3]                    	= true;
    stateAllowImageChange[3]        	= false;
    stateSequence[3]                	= "Fire";
    stateScript[3]                  	= "onFire";
    stateWaitForTimeout[3]        	= true;

    stateName[5]                    	= "StopFire";
    stateTransitionOnTimeout[5]     	= "Ready";
    stateTimeoutValue[5]            	= 0.6;
    stateAllowImageChange[5]        	= false;
    stateWaitForTimeout[5]        	= true;
    stateSequence[5]                	= "StopFire";
    stateScript[5]                  	= "onStopFire";


};

function TailImage::onPreFire(%this, %obj, %slot)
{
    %obj.playthread(2, armattack);
}

function TailImage::onStopFire(%this, %obj, %slot)
{    
    %obj.playthread(2, root);
}

// This is the function that checks if the thing is raycastingly critasmic.
function TailImage::isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal, %hit)
{
	%fv = vectorNormalize(getWords(%obj.getVelocity(),0,1));
        %stab = (vectorDot(%fv,%col.getForwardVector()) > 0);

	if(%stab)
	    return 1;
	else
	    return 0;
}